Subject: Re: bug#55386: 29.0.50; check-declare-directory doesn't work on Windows

From: Eli Zaretskii <[email-masked]>
Date: Sat, 14 May 2022 15:05:56 +0300

> From: Lars Ingebrigtsen <[email-masked]>
> Cc: [email-masked],  [email-masked]
> Date: Sat, 14 May 2022 13:40:11 +0200
> 
> > -  (let ((files (process-lines-ignore-status
> > -                find-program root
> > -                "-name" "*.el"
> > -                "-exec" grep-program
> > -                "-l" "^[ \t]*(declare-function" "{}" "+")))
> > +  (let ((files (directory-files-recursively root "\\.el\\'")))
> >      (when files
> >        (apply #'check-declare-files files))))
> 
> I'm surprised that it's just 9% slower -- there's 2K files in the Emacs
> tree, and only one a quarter of them have a declare-function.  Is
> process-lines-ignore-status really slow or something?

I don't know if it's really slow, but it runs Grep on each file, and
that slows down the command it launches.  directory-files-recursively
is much faster, but then check-declare-files has more files to check.

I think the slowdown depends on the system and on the build.  I only
tested in unoptimized builds, and the GNU/Linux system to which I have
access is a relatively slow VM.  So maybe you should time this
yourself before we decide whether the slow-down is acceptable?

Or what kind of slow-down can we endure before we feel uneasy about
the change?

> But the change looks fine to me in any case.

I can install now if you are okay with the above.